
// version 0.51, Julian Rohrhuber 2001/05
// a field of Dimmers
// keep option key down to paste the last used color

// array2d is an array of ControlValues
// that can conveniently be created by ControlArray2D

BasicField : View { 
	var <>array2D, <rows, <cols;
	var <>bounds, <>lastVal=0;
	
	*new { arg pen, bounds, array2D, enabled=true, visible=true, layoutSize;
		
		^super.newCopyArgs( 
			pen.asPen, nil, enabled, visible, layoutSize ?? { LayoutSize.new })
			.bounds_(bounds)
			.array2D_(array2D)
			.init
			
	}
	
	init { 
			rows = array2D.rows;
			cols = array2D.cols;
			items = Array2D.new(rows,cols);
	}
	
	
	calcItem { ^this.subclassResponsibility }
	
	at { arg row, col;
		^items.at(
			row.asInteger.wrap(0, rows-1), 
			col.asInteger.wrap(0, cols-1))
	}
	
	
	
	
}

Field : BasicField { 
	
	
	*new { arg pen, bounds, array2D, enabled=true, visible=true, layoutSize;
				^super.new(pen, bounds, array2D, enabled=true, visible=true, layoutSize).initItems.update;
	}
	
	initItems {
			var width, height;
			width = bounds.width / cols;
			height = bounds.height / rows;
			
			rows.do({ arg row;
				cols.	do({ arg col;
					var dimmer, rect;
					rect = Rect.newBy(bounds.left + (width * col), bounds.top + (height * row), width, height);
					dimmer = FieldDimmer.new(pen.copy, rect, array2D.array2D.at(row, col), value: array2D.at(row, col), field: this);
					items = items.put(row, col,  dimmer);
				})
			})
		
	}
	

	 
}

Field2 : BasicField {
	
	var <>indices, <>colors;
	
	*new { arg pen, bounds, array2D, indices, colors, enabled=true, visible=true, layoutSize;
		^super.new( pen, bounds, array2D, enabled=true, visible=true, layoutSize)
			.indices_(indices).colors_(colors).initItems;
	}
	
	
	initItems { 
			var width, height;
			width = bounds.width / cols;
			height = bounds.height / rows;
			"initItems".postln;
			
			
			if(colors.isNil, { this.autoColorize });
			colors.postln;
			rows.do({ arg row;
				cols.	do({ arg col;
					var dimmer, rect;
				
					rect = Rect.newBy(bounds.left + (width * col), bounds.top + (height * row), width, height);
					dimmer = FieldDimmer2.new(pen.copy, rect, value: array2D.at(row, col), field: this);
					dimmer.action_({ 
						array2D.at(row, col).set(dimmer.value);
						indices.at(row, col).set(dimmer.index);
				
					});
					items = items.put(row, col, dimmer)
				})
			})
			
	}

	
	
	autoColorize { arg n=4;
		colors = Array.fill(n, { arg i;
				Color.hsv(255 *i div: n , 200, 200)
		})
	}
		
}
	
	
