//version 0.3, Julian Rohrhuber 2001/05
//patterns to iterate over Array2D or ControlArray2D



Pattern2D : Pattern { 
		var <>array2D, <>repeats;
	*new { arg array2D, repeats=1;
		^super.newCopyArgs(array2D, repeats);
	}
}

Prow : Pattern2D {
	//walks through one row
	var <>row;
	*new { arg array2D, row, repeats=1;
		^super.new(array2D, repeats).row_(row);
	}

	asStream { 
		^Routine.new({ arg inval;
			var rowValue;
			rowValue = row.value;
			repeats.value.do({
				array2D.doRow(rowValue, { arg item; item.embedInStream(inval) })
			})
			})
	}
	
}
Pcols : Pattern2D {
	//returns an array (col) each next
	asStream { 
		^Routine.new({ arg inval;
			repeats.value.do({
					array2D.cols.do({ arg col;
						array2D.col(col).yield(inval)
					})
			})
		})
	}
} 

Prows : Pattern2D {
	//returns an array (row) each next
	asStream { 
		^Routine.new({ arg inval;
			repeats.value.do({
					array2D.rows.do({ arg row;
						array2D.row(row).embedInStream(inval)
					})
			})
		})
	}
}						

Pweave : Pattern2D {
	//walks through all rows one after the other	
	asStream { arg repeats=inf;
		^Routine.new({ arg inval;
			repeats.value.do({
				array2D.do({ arg item;
					item.embedInStream(inval)
				})
			})
		})
	}
}





FieldPattern : Pattern {
	var <>field, <>repeats;
	*new { arg field, repeats=1;
		^super.newcopyArgs(field, repeats);
	}
	array2D { ^field.array2D }
}




